package quad_tree;

import java.awt.*;

public class QuadTree {

    private final static Point DEFAULT_TL = new Point(0, 0);
    private final static Point DEFAULT_BR = new Point(128, 128);

    private QTNode root;
    private int size;

    public QuadTree(Point tl, Point br) {
        root = new QTLeaf(tl, br);
    }

    public QuadTree() {
        this(DEFAULT_TL, DEFAULT_BR);
    }

    public boolean insert(Point p) {
        root = root.insert(p);
        return true;
    }

    public static void printTreeHelper(QTNode sRoot, String padding) {
        // Check for empty leaf
        if (sRoot.isLeaf() && ((QTLeaf) sRoot).getPoint() == null) {
            System.out.println(padding + "*\n");
            return;
        }
        // Check for and process SW and SE subtrees
        if (!sRoot.isLeaf()) {
            QTIntl p = (QTIntl) sRoot;
            printTreeHelper(p.getBotLeftTree(), padding + "----");
            printTreeHelper(p.getBotRightTree(), padding + "----");
        }
        // Display indentation padding for current node
        System.out.print(padding);
        // Determine if at leaf or internal and display accordingly
        if (sRoot.isLeaf()) {
            QTLeaf p = (QTLeaf) sRoot;
            System.out.println(p.getPoint());
        } else {
            System.out.println("@\n");
        }
        if (!sRoot.isLeaf()) {
            QTIntl p = (QTIntl) sRoot;
            printTreeHelper(p.getTopRightTree(), padding + "----");
            printTreeHelper(p.getTopLeftTree(), padding + "----");
        }
    }


    public Point find(Point p) {
        return null;
    }

    public Point remove(Point p) {
        return null;
    }

    public static void main(String[] args) {
        QuadTree qt = new QuadTree();

        // NW
        qt.insert(new Point(40, 45));

        // NE
        //      NW
        qt.insert(new Point(70, 10));
        //      SW
        qt.insert(new Point(69, 50));

        // SW
        qt.insert(new Point(15, 70));

        // SE
        //      NW
        //          SW
        qt.insert(new Point(55, 80));
        //          SE
        qt.insert(new Point(80, 90));

        printTreeHelper(qt.root, "");

    }

}
